<?php
class pvs_generate_video_sitemap {
     public function __construct() {
	 global $pvs_options;
	 add_action('wp_ajax_update_pvssitemap', array(&$this, 'pvs_video_sitemap_ajax_generate'));
	 if  ((isset($pvs_options['autoupdate'])) && ($pvs_options['autoupdate'] == "on") )  {
         add_action('draft_to_publish', array(&$this, 'pvs_generate_video_sitemap_function'));
		 add_action('new_to_publish', array(&$this, 'pvs_generate_video_sitemap_function'));
		 add_action('pending_to_publish', array(&$this, 'pvs_generate_video_sitemap_function'));
		 add_action('private_to_publish', array(&$this, 'pvs_generate_video_sitemap_function'));
		 add_action('publish_to_publish', array(&$this, 'pvs_generate_video_sitemap_function'));

     }
	 
	 }
	
    public function pvs_video_sitemap_ajax_generate() {
    $this->pvs_generate_video_sitemap();
	die();
    }	
	
	public function pvs_generate_video_sitemap() {
	$this->pvs_generate_video_sitemap_function();
	global $pvs_options;
	if (isset($pvs_options['xmltitle']) && ($pvs_options['xmltitle'] == "on") && ($pvs_options['xmltitlename'] != '')) {
	$sitemaptitle=$pvs_options['xmltitlename'];
    } else {
	$sitemaptitle='video-sitemap';
    }
    if ( isset($pvs_options['folder']) && $pvs_options['foldername'] !='' ) {
    echo 'Your <a href="'.site_url().'/'.$pvs_options['foldername'].'/'.$sitemaptitle.'.xml">video sitemap</a> has been updated successfully.';
    } else {	
	echo 'Your <a href="'.site_url().'/'.$sitemaptitle.'.xml">video sitemap</a> has been updated successfully.';
	}
	}
	 
	public function pvs_generate_video_sitemap_function() 
    {   

     global $post;

     global $pvs_options;

        if (isset($pvs_options['xmltitle']) && ($pvs_options['xmltitle'] == "on") && ($pvs_options['xmltitlename'] != '')) {
	        $sitemaptitle=$pvs_options['xmltitlename'];
        } else {
	        $sitemaptitle='video-sitemap';
        }  
		
     $videopost_types=get_post_types(); 

     $videoposttypes_array = array();
     foreach ($videopost_types  as $videopost_type ) {
     $videoposttypes_array[] = $videopost_type;
     }
    
     $args=array(
     'numberposts'=> -1,
     'orderby'=>'modified',
     'post_type'  => $videoposttypes_array
     );
	 
	
     $videos =get_posts( $args );
	 $videos = json_decode(json_encode($videos), true);
	 
	
	 if ( isset($pvs_options['multiple'])) {
     $sitevideocounts  = count($videos);
	 
	 $allowedentries   = $pvs_options['multiplenumber'];
	 
	 $numberofsitemaps = $sitevideocounts / $allowedentries;
	 $numberofsitemaps = (int)$numberofsitemap; 
	 $numberofsitemaps = $numberofsitemap + 1;
	 }
	 
     $sitemap  = '<?xml version="1.0" encoding="UTF-8"?>' . "\n"; 
      if ( isset($pvs_options['multiple']) && ($sitevideocounts > $allowedentries)) {
	 $sitemap .= '<?xml-stylesheet type="text/xsl" href="' . site_url() . '/wp-content/plugins/ultimate-video-seo/videoindex.xsl"?>' . "\n";
	 } else {
     $sitemap .= '<?xml-stylesheet type="text/xsl" href="' . site_url() . '/wp-content/plugins/ultimate-video-seo/videostyle.xsl"?>' . "\n";
	}
    
	if ( isset($pvs_options['multiple']) &&  ($sitevideocounts >  $allowedentries)) {
	$sitemap .='<sitemapindex xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . "\n";
	} else {
	$sitemap .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:video="http://www.google.com/schemas/sitemap-video/1.1">' . "\n"; 
	}
	
      
	
	  if (( isset($pvs_options['multiple']) ) && ($sitevideocounts >  $allowedentries)) {
     
	 $counter = 0;
	 $sitemapcount= 1 ;
	 $childsitemapheader  = '';
	 $childsitemapheader .= '<?xml version="1.0" encoding="UTF-8"?>' . "\n"; 
     $childsitemapheader .= '<?xml-stylesheet type="text/xsl" href="' . site_url() . '/wp-content/plugins/ultimate-video-seo/videostyle.xsl"?>' . "\n";
	 $childsitemapheader .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:video="http://www.google.com/schemas/sitemap-video/1.1">' . "\n"; 
	 $childsitemapcontent[$sitemapcount] = '';
	 $childsitemapfooter  = '</urlset>';
	 
	 foreach ($videos as $video) {
	 
	
	 
	 $vid = $video['ID'];
	 
	 
	 
     $vidpermalink    = get_permalink($vid);
     $thumbloc        = get_post_meta( $vid, 'thumbloc', true );
     $thumbtitle      = get_post_meta( $vid, 'thumbtitle', true );
     $thumbtitle2     = '<![CDATA['.$thumbtitle.']]>';
     $thumbdesc       = get_post_meta( $vid, 'thumbdesc', true );
     $thumbdesc2      = '<![CDATA['.$thumbdesc.']]>';
     $thumbdate       = get_post_meta( $vid, 'thumbdate', true );
     $thumbplayer     = get_post_meta( $vid, 'thumbplayer', true );
     $thumbfileloc    = get_post_meta( $vid, 'thumbfileloc', true );
     $thumbduration   = get_post_meta( $vid, 'thumbduration', true );
     $thumbauthor     = get_post_meta( $vid, 'thumbauthor', true );
     $thumbauthorname = get_post_meta( $vid, 'thumbauthorname', true );
     $thumbpubdate    = get_post_meta( $vid, 'thumbpubdate', true );
     $family          = get_post_meta( $vid, 'family', true );
     $pvsdisable      = get_post_meta( $vid, 'pvsdisable', true );
	    
     $videocategories = get_the_category($vid);   
	 $videocategory   = $videocategories[0]->cat_name;
	 
	 $videotags       = wp_get_post_tags($vid);
     
		
		
     if ($family) {$thumbfamily = 'no';} else {$thumbfamily = 'yes';}
					$permalink = get_permalink($vid); 
					$videotitle = get_the_title($vid);
					
	
	 
					if (($thumbloc) && ($pvsdisable != "yes"))  {
					$childsitemapcontent[$sitemapcount] .= "<url>\n";
					$childsitemapcontent[$sitemapcount] .= " <loc>$vidpermalink</loc>\n"; }
					
			        
					
					if (($thumbloc) && ($pvsdisable != "yes")) {
					$childsitemapcontent[$sitemapcount] .= " <video:video>\n";
					$childsitemapcontent[$sitemapcount] .= " <video:thumbnail_loc>$thumbloc</video:thumbnail_loc>\n"; }
					if (($thumbtitle) && ($thumbloc) && ($pvsdisable != "yes") )  {
					$childsitemapcontent[$sitemapcount] .= " <video:title>$thumbtitle2</video:title>\n"; }
					if (($thumbdesc) && ($thumbloc) && ($pvsdisable != "yes") )  {
					$childsitemapcontent[$sitemapcount] .= " <video:description>$thumbdesc2</video:description>\n"; }
					
					if (($thumbdate) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:rating>$thumbdate</video:rating>\n"; }
					
					if (($thumbfamily) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:family_friendly>$thumbfamily</video:family_friendly>\n"; }
					
					if (($thumbplayer) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:player_loc allow_embed='yes' >$thumbplayer</video:player_loc>\n";
					}
					
					if (($thumbfileloc) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:content_loc>$thumbfileloc</video:content_loc>\n";
					}
				    
					if ((($videocategory) && ($videocategory != "Uncategorized")) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:category>$videocategory</video:category>\n"; 
					}
					foreach ($videotags as $tag) {
					$videotag        = $tag->name;
					if (($videotag) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:tag>$videotag</video:tag>\n"; 
					}
					}
					
					if (($thumbduration) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:duration>$thumbduration</video:duration>\n"; 
					}
					if (($thumbauthor) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:uploader info='$thumbauthor'>$thumbauthorname</video:uploader>\n"; 
					}
					if (($thumbpubdate) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$childsitemapcontent[$sitemapcount] .= " <video:publication_date>$thumbpubdate</video:publication_date>\n"; 
					}
					if (($thumbloc) && ($pvsdisable != "yes")) 
					{ $childsitemapcontent[$sitemapcount] .= " </video:video>\n"; }
					
					if (($thumbloc) && ($pvsdisable != "yes")) {
					$childsitemapcontent[$sitemapcount] .= "</url>\n"; }
	    
		    
		    
	    if ( ($counter % $allowedentries == 0) && ($childsitemapcontent[$sitemapcount] != '')) {
	 
		$childsitemap = $childsitemapheader . $childsitemapcontent[$sitemapcount] . $childsitemapfooter ;
             
		if ( isset($pvs_options['folder']) && $pvs_options['foldername'] !='' ) {
	     
		 if (isset($pvs_options['gzip'])) {
		 $fp = gzopen(ABSPATH . "".$pvs_options['foldername']."/".$sitemaptitle."-".$sitemapcount.".xml.gz", 'w');
		 $sitemapurl=''.site_url().'/'.$pvs_options['foldername'].'/'.$sitemaptitle.'-'.$sitemapcount.'.xml.gz';
		 } else {
		 $fp = fopen(ABSPATH . "".$pvs_options['foldername']."/".$sitemaptitle."-".$sitemapcount.".xml", 'w');
	     $sitemapurl=''.site_url().'/'.$pvs_options['foldername'].'/'.$sitemaptitle.'-'.$sitemapcount.'.xml';
		 }
	    } else {
		if (isset($pvs_options['gzip'])) {
		  $fp = gzopen(ABSPATH . "".$sitemaptitle."-".$sitemapcount.".xml.gz", 'w');
		 $sitemapurl=''.site_url().'/'.$sitemaptitle.'-'.$sitemapcount.'.xml.gz';
		 } else {
	     $fp = fopen(ABSPATH . "".$sitemaptitle."-".$sitemapcount.".xml", 'w');
		 $sitemapurl=''.site_url().'/'.$sitemaptitle.'-'.$sitemapcount.'.xml';
		 }
	    }
		
		if (isset($pvs_options['gzip'])) {
		gzwrite($fp, $childsitemap);
        gzclose($fp);
		} else {
	    fwrite($fp , $childsitemap);   
	    fclose($fp); 
		}
		
		$date     =$video['post_modified'];
		$sitemap .= "<sitemap>\n";
	    $sitemap .= "<loc>$sitemapurl</loc>\n"; 
		$sitemap .= "<lastmod>" . htmlspecialchars( $date ) . "</lastmod>\n"; 
		$sitemap .= "</sitemap>\n";			
	    $sitemapcount++;	
		
		}
		
    if (($thumbloc) && ($pvsdisable != "yes")) {
	$counter++;
	}
	}
	$sitemap .= '</sitemapindex>';  
	
	} else {
	 
     foreach ($videos as $video) { 
	 $vid = $video['ID'];
     $vidpermalink    = get_permalink($vid);
     $thumbloc        = get_post_meta( $vid, 'thumbloc', true );
     $thumbtitle      = get_post_meta( $vid, 'thumbtitle', true );
     $thumbtitle2     = '<![CDATA['.$thumbtitle.']]>';
     $thumbdesc       = get_post_meta( $vid, 'thumbdesc', true );
     $thumbdesc2      = '<![CDATA['.$thumbdesc.']]>';
     $thumbdate       = get_post_meta( $vid, 'thumbdate', true );
     $thumbplayer     = get_post_meta( $vid, 'thumbplayer', true );
     $thumbfileloc    = get_post_meta( $vid, 'thumbfileloc', true );
     $thumbduration   = get_post_meta( $vid, 'thumbduration', true );
     $thumbauthor     = get_post_meta( $vid, 'thumbauthor', true );
     $thumbauthorname = get_post_meta( $vid, 'thumbauthorname', true );
     $thumbpubdate    = get_post_meta( $vid, 'thumbpubdate', true );
     $family          = get_post_meta( $vid, 'family', true );
     $pvsdisable      = get_post_meta( $vid, 'pvsdisable', true );
	 
	 $videocategories = get_the_category($vid); 
     if (!empty($videocategories))	 
	 $videocategory   = $videocategories[0]->cat_name;
	 
	 $videotags       = wp_get_post_tags($vid);
	 
     if ($family) {$thumbfamily='no';} else {$thumbfamily='yes';}
					$permalink = get_permalink($vid); 
					$videotitle = get_the_title($vid);
					
	
	 
					if (($thumbloc) && ($pvsdisable != "yes"))  {
					$sitemap .= "<url>\n";
					$sitemap .= " <loc>$vidpermalink</loc>\n"; }
					
			        
					
					if (($thumbloc) && ($pvsdisable != "yes")) {
					$sitemap .= " <video:video>\n";
					$sitemap .= " <video:thumbnail_loc>$thumbloc</video:thumbnail_loc>\n"; }
					if (($thumbtitle) && ($thumbloc) && ($pvsdisable != "yes") )  {
					$sitemap .= " <video:title>$thumbtitle2</video:title>\n"; }
					if (($thumbdesc) && ($thumbloc) && ($pvsdisable != "yes") )  {
					$sitemap .= " <video:description>$thumbdesc2</video:description>\n"; }
					
					if (($thumbdate) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:rating>$thumbdate</video:rating>\n"; }
					
					if (($thumbfamily) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:family_friendly>$thumbfamily</video:family_friendly>\n"; }
					
					if (($thumbplayer) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:player_loc allow_embed='yes' >$thumbplayer</video:player_loc>\n";
					}
					
					if (($thumbfileloc) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:content_loc>$thumbfileloc</video:content_loc>\n";
					}
					
					if (($thumbduration) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:duration>$thumbduration</video:duration>\n"; 
					}
					
					if ((($videocategory) && ($videocategory != "Uncategorized")) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:category>$videocategory</video:category>\n"; 
					}
					
						foreach ($videotags as $tag) {
					$videotag        = $tag->name;
					if (($videotag) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:tag>$videotag</video:tag>\n"; 
					}
					}
					
					if (($thumbauthor) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:uploader info='$thumbauthor'>$thumbauthorname</video:uploader>\n"; 
					}
					if (($thumbpubdate) && ($thumbloc) && ($pvsdisable != "yes") ) {
					$sitemap .= " <video:publication_date>$thumbpubdate</video:publication_date>\n"; 
					}
					if (($thumbloc) && ($pvsdisable != "yes")) 
					{$sitemap .= " </video:video>\n";}
					
					if (($thumbloc) && ($pvsdisable != "yes")) {
					$sitemap .= "</url>\n"; }
					
				                          
					
			            
						}
	
	
    
        $sitemap .= '</urlset>';
		

		
            
    }

    if ( isset($pvs_options['folder']) && $pvs_options['foldername'] !='' ) {
	$fp = fopen(ABSPATH . "".$pvs_options['foldername']."/".$sitemaptitle.".xml", 'w');
	$sitemapurl=''.site_url().'/'.$pvs_options['foldername'].'/'.$sitemaptitle.'.xml';
	} else {
	$fp = fopen(ABSPATH . "".$sitemaptitle.".xml", 'w');
	$sitemapurl=''.site_url().'/'.$sitemaptitle.'.xml';
	}
	
        
	fwrite($fp , $sitemap);   
	fclose($fp ); 
	update_option('pvs_sitemap_url',$sitemapurl);
    update_option('pvs_sitemap_generation_time',''.current_time( 'mysql' ).'');	
	
	
	}
	

}
new pvs_generate_video_sitemap();
?>