<?php
/*
Plugin Name: ultimate video seo plugin (shared on wplocker.com)
Plugin URI: http://phppoet.com/wordpress-ultimate-video-seo-plugin/
Description: Video seo plugin for worpdress. 
Version: 1.3
Author: Parbat chaudhari
Author URI: http://phppoet.com
*/




/*
 * global variables 
 */

$pvs_options = get_option('pvs_settings');

$pvs_meta_options = get_option('pvs_meta_settings');

$pvs_sitemap_options = get_option('pvs_sitemap_settings');



//define plugin url
if( !defined( 'pvs_PLUGIN_URL' ) )
define( 'pvs_PLUGIN_URL', plugin_dir_url( __FILE__ ) );

if(function_exists('register_activation_hook'))
	register_activation_hook(__FILE__, 'pvs_activation_hook'); 
	
function pvs_activation_hook() {
if (!get_option( 'pvs_activation_status' )) {
add_option( 'pvs_activation_status', 'Unverified', '', 'yes' );
}

if (!get_option( 'pvs_licence_type' )) {
add_option( 'pvs_licence_type', 'Unverified', '', 'yes' );
}

if (!get_option( 'pvs_sitemap_url' )) {
add_option( 'pvs_sitemap_url', 'Not generated yet', '', 'yes' );
}
if (!get_option( 'pvs_sitemap_generation_time' )) {
add_option( 'pvs_sitemap_generation_time', 'Never', '', 'yes' );
}
if (!get_option( 'pvs_ping_time' )) {
add_option( 'pvs_ping_time', 'Never', '', 'yes' );
}
}



 
load_plugin_textdomain('pvsseo', false, basename( dirname( __FILE__ ) ) . '/languages' );  
 
	 

require 'plugin-updates/plugin-update-checker.php';
$MyUpdateChecker = new PluginUpdateChecker(
    'http://phppoet.com/pvs-update.js',
    __FILE__,
    'ultimate-video-seo'
); 


require ('metabox/seo-meta-box.php'); //metabox for seo
require ('metabox/noerror.php'); //No Error
require ('classes/pvs-admin-settngs-class.php'); //Admin Settings Class
require ('classes/pvs_generate_video_sitemap_class.php'); //Sitemap generation class
require ('classes/pvs_png_sitemap_class.php'); //Sitemap generation class
require ('classes/pvs_schema_markup_class.php'); //schema markup class
require ('classes/pvs_opengraph_meta_tags_class.php'); //Opengraph tags class







?>