<?php
class pvs_admin_settings_class {
    public function __construct() {
	add_action('admin_enqueue_scripts', array(&$this, 'pvs_register_scripts'));
	add_action('wp_ajax_pvs_onload', array(&$this, 'pvs_onload_function'));
	add_action('admin_menu', array(&$this, 'pvs_add_options_link'));
	add_action('admin_init', array(&$this, 'pvs_register_settings'));
	
	

	
	}
	
	 public function pvs_add_options_link() {
	 
	 add_menu_page(''.__('Video Seo Plugin Options','pvsseo').'',''.__('Video Seo ','pvsseo').'','manage_options','pvs-options',array(&$this, 'pvs_options_page'));

	 add_submenu_page( 'pvs-options', ''.__('Sitemap ','pvsseo').'',''.__('Sitemap ','pvsseo').'' , 'manage_options', 'sitemap-settings', array(&$this, 'pvs_sitemap_settings') );
	
	}
	 	 
     

	 
	 public function pvs_options_page() {

     global $pvs_options;
     ob_start(); ?>
	 
	  <div class="wrap">
	
	
	 
	
	 <form method="post" action="options.php">
	 
	 <?php settings_fields('pvs_settings_group');  wp_enqueue_script('pvs2'); wp_enqueue_style('pvs1'); ?>
	 <table class="widefat">
      <thead>
        <tr>
          <th scope="col" style="width: 40%;"><?php echo __('Video Seo Settings','pvsseo'); ?></th><th></th>
        </tr>
      </thead>
	  
	
    <tr> <td><label class="checkbox" for="pvs_settings[pvs_rich]" ><font size="02"> <?php echo __('Disable schema.org markup on video pages for rich snippets(not recommended)','pvsseo'); ?></font></td>
    <td>
	<div class="toggle">
	<input type="checkbox" name="pvs_settings[pvs_rich]" id="pvs_settings[pvs_rich]" class="toggle-checkbox" value="yes" <?php if (isset($pvs_options['pvs_rich'])) { echo 'checked';}  ?> /> 
    <label class="toggle-label" for="pvs_settings[pvs_rich]">
    <div class="toggle-internal"></div>
	</label></td></tr>  
	    <tr> <td><label class="checkbox" for="pvs_settings[opengraph]" ><font size="02"> <?php echo __('Disable Opengraph video meta tags(not recommended)','pvsseo'); ?></font></td>
    <td>
	<div class="toggle">
	<input type="checkbox" name="pvs_settings[opengraph]" id="pvs_settings[opengraph]" class="toggle-checkbox" value="yes" <?php if (isset($pvs_options['opengraph'])) { echo 'checked';}  ?> /> 
    <label class="toggle-label" for="pvs_settings[opengraph]">
    <div class="toggle-internal"></div>
	</label></td></tr>  
     <tr>
		 <td>
		 <label for="pvs_settings[autoupdate]"><font size="02"><?php _e( 'Automatically update sitemap when video Post is updated(recommended)', 'pvs' ); ?></font></label>
		 </td>
		 <td class="widefat">
		 <div class="toggle">
       <input id="pvs_settings[autoupdate]" name="pvs_settings[autoupdate]" class="toggle-checkbox" type="checkbox" value="on"   <?php if (isset($pvs_options['autoupdate'])) {echo "checked";}?> />
		  <label class="toggle-label" for="pvs_settings[autoupdate]">
                <div class="toggle-internal"></div>
		 </td>
		 </tr> 
      		 <tr>
		 <td>
		 <label for="pvs_settings[autoping]"><font size="02"><?php _e( 'Automatically ping sitemap when video Post has been created', 'pvs' ); ?></font></label>
		 </td>
		 <td class="widefat">
		 <div class="toggle">
       <input id="pvs_settings[autoping]" name="pvs_settings[autoping]" class="toggle-checkbox" type="checkbox" value="on"   <?php if (isset($pvs_options['autoping'])) {echo "checked";}?> />
		  <label class="toggle-label" for="pvs_settings[autoping]">
                <div class="toggle-internal"></div>
		 </td>
		 </tr> 		 
	 <tr>
		 <td>
		 <label for="pvs_settings[xmltitle]"><font size="02"><?php _e( 'use different xml sitemap name', 'pvs' ); ?></font></label>
		 </td>
		 <td class="widefat">
		 <div class="toggle">
       <input id="_xmltitletrcheckbox" name="pvs_settings[xmltitle]" class="toggle-checkbox" type="checkbox" value="on"   <?php if (isset($pvs_options['xmltitle'])) {echo "checked";}?> />
		  <label class="toggle-label" for="_xmltitletrcheckbox">
                <div class="toggle-internal"></div>
		 </td>
		 </tr>
		 <tr id="_xmltitletr" style="<?php if (!isset($pvs_options['xmltitle'])) { echo "display:none;"; }  ?>">
		 <td>
		 <label for="pvs_settings[xmltitlename]"><font size="02"><?php _e( 'file name', 'pvs' ); ?></font></label>
		
		 </td>
		 <td class="widefat">
		
       <input id="pvs_settings[xmltitlename]" name="pvs_settings[xmltitlename]"  type="text" value="<?php if ((isset($pvs_options['xmltitlename'])) && ($pvs_options['xmltitlename'] != '')) { echo $pvs_options['xmltitlename']; } else { echo "video-sitemap"; }?>"    />.xml
		  
               
		 </td>
		 </tr>
		 
		 	 <tr>
		 <td>
		 <label for="pvs_settings[multiple]"><font size="02"><?php _e( 'Enable Mulitple Sitemap Mode', 'pvs' ); ?></font></label>
		 <p><font size="01"><?php _e('Google recommend maximum 500 entries per sitemap . Enable this if you have more then 500 videos. ','pvs'); ?> </font></p>
		 </td>
		 <td class="widefat">
		 <div class="toggle">
       <input id="_multiplecheckbox" name="pvs_settings[multiple]" class="toggle-checkbox" type="checkbox" value="on"   <?php if (isset($pvs_options['multiple'])) {echo "checked";}?> />
		  <label class="toggle-label" for="_multiplecheckbox">
                <div class="toggle-internal"></div>
		 </td>
		 </tr>
		 <tr id="_multipletr" style="<?php if (!isset($pvs_options['multiple'])) { echo "display:none;"; }  ?>">
		 <td>
		 <label for="pvs_settings[multiplenumber]"><font size="02"><?php _e( 'Maximum Entries Per Sitemap', 'pvs' ); ?></font></label>
		 <p><font size="01"><?php _e('It must not exceed 500. If total site videos are less then this number then common video sitemap will be generated. ','pvs'); ?> </font></p>
		 </td>
		 <td class="widefat">
		
       <input id="pvs_settings[multiplenumber]" name="pvs_settings[multiplenumber]"  type="number" min="1" max="500" value="<?php if ((isset($pvs_options['multiple'])) && ($pvs_options['multiplenumber'] != '')) { echo $pvs_options['multiplenumber']; } else { echo "500"; }?>"    />
		  
               
		 </td>
		 </tr >
		 <tr id="_multipletr2" style="<?php if (!isset($pvs_options['multiple'])) { echo "display:none;"; }  ?>">
		 <td>
		 <label for="pvs_settings[gzip]"><font size="02"><?php _e( 'Use gzipped sitemap files instead of xml', 'pvs' ); ?></font></label>
		 </td>
		 <td class="widefat">
		 <div class="toggle">
       <input id="pvs_settings[gzip]" name="pvs_settings[gzip]" class="toggle-checkbox" type="checkbox" value="on"   <?php if (isset($pvs_options['gzip'])) {echo "checked";}?> />
		  <label class="toggle-label" for="pvs_settings[gzip]">
                <div class="toggle-internal"></div>
		 </td>
		 </tr>
		 
		 <tr>
		 <td>
		 <label for="pvs_settings[folder]"><font size="02"><?php _e( 'Write sitemaps into a folder', 'pvs' ); ?></font></label>
		 </td>
		 <td class="widefat">
		 <div class="toggle">
       <input id="_foldernamecheckbox"  name="pvs_settings[folder]" class="toggle-checkbox" type="checkbox" value="on"   <?php if (isset($pvs_options['folder'])) {echo "checked";}?> />
		  <label class="toggle-label" for="_foldernamecheckbox">
                <div class="toggle-internal"></div>
		 </td>
		 </tr>
		 <tr id="_foldernametr" style="<?php if (!isset($pvs_options['folder'])) { echo "display:none;"; }  ?>">
		 <td>
		 <label for="pvs_settings[foldername]"><font size="02"><?php _e( 'folder name', 'pvs' ); ?></font></label>
		 <p><font size="01"> <?php echo __('Folder will be created by plugin so do not create it ','pvs'); ?> </font></p>
		 </td>
		 <td class="widefat">
		
       <input id="pvs_settings[foldername]" name="pvs_settings[foldername]"  type="text" value="<?php if (isset($pvs_options['foldername'])) { echo $pvs_options['foldername']; } else { echo "sitemap"; }?>"    />
		  
               
		 </td>
		 </tr>
		 
		 <tr>
		 <td>
		 <label for="pvs_settings[robots]"><font size="02"><?php _e( 'Add sitemap index file to robots.txt', 'pvs' ); ?></font></label>
		 </td>
		 <td class="widefat">
		  <div class="toggle">
       <input id="pvs_settings[robots]" name="pvs_settings[robots]" class="toggle-checkbox" type="checkbox" value="on"   <?php if (isset($pvs_options['robots'])) {echo "checked";}?> />
		   <label class="toggle-label" for="pvs_settings[robots]">
                <div class="toggle-internal"></div>
		 </td>
		 </tr>
	

    	<?php 
		$sitemaplocaton = get_option('pvs_sitemap_url');
		if (isset($pvs_options['robots'])) {
    $file = ''.ABSPATH.'robots.txt';
	
    $sitemapurl="Sitemap: $sitemaplocaton \n";
    // Open the file to get existing content
    $current = file_get_contents($file);
    $current = str_replace($sitemapurl, "", $current);
    $current .= $sitemapurl;
    // Write the contents back to the file
    file_put_contents($file, $current);
	} else  {
	 $file = ''.ABSPATH.'robots.txt';
	$sitemapurl="Sitemap: $sitemaplocaton \n";
    // Open the file to get existing content
    $current = file_get_contents($file);
    $current = str_replace($sitemapurl, "", $current);

    file_put_contents($file, $current);
	}
	
	if ( isset($pvs_options['folder']) && $pvs_options['foldername'] !='' ) {
	 $dir="".ABSPATH."/".$pvs_options['foldername']."";
	   if (!is_dir($dir)) {
	   mkdir($dir, 0700);
	   }
	}
	?> 
 
	
    </table>
    <div id="pvsveifystatus" style="display:none; background-color:#ffffe0; border-color: #e6db55;  border-width: 1px; border-style: solid; width :auto; height:auto;"> </div>
		
		<br />		<br /><br />		
    <center>	 <input type="submit" value="Update options" class="button-primary" /></center> </center>
     </form>
	
	 </div>
	
     <br /><br />
	 
	
	 

	 
	 
	 <br />

	 <?php
	 
	
    }
	 
	 public function pvs_sitemap_settings() {
	 ?>
	 <div class="wrap">
     <?php global $pvs_sitemap_options; ?>
    <form method="post" action="options.php">
	 <?php 
     wp_enqueue_script('pvs1');	 ?>
	<table class="widefat">
      <thead>
        <tr>
          <th scope="col" style="width: 40%;"><?php echo __('Sitemap Actions','pvs'); ?></th><th></th>
        </tr>
      </thead>

        <tbody>
	<tr><td><?php _e('Sitemap Address','pvs'); ?></td> <td><?php if (get_option('pvs_sitemap_url') != "Not generated yet") { ?> <a href="<?php echo get_option('pvs_sitemap_url'); ?>"><?php echo get_option('pvs_sitemap_url'); ?></a> <?php } else { echo "Not generated yet"; } ?></td></tr>
   <tr><td><font size="02" style="float:left"><?php echo __('Click on Generate sitemap to generate your sitemap ','pvs'); ?></font></td><td><div style="float:left;">&emsp;&emsp;&emsp;</div><input id="pvsgeneratesitemap" type="button" value="Generate Sitemap" class="button-primary" style="float:left;"  /><img  src="<?php echo pvs_PLUGIN_URL; ?>/images/ajax-loader.gif"  class="waiting" id="pvsgenerate" style="display:none; float:left;">&emsp;&emsp;&emsp;<b><?php _e('Previously Generated On','pvs'); ?>:</b><font color="green"><b><?php echo get_option('pvs_sitemap_generation_time'); ?></b></font></td>
   <tr><td><font size="02" style="float:left"><?php echo __('Click on Ping sitemap to notify sitemap to search engines','pvs'); ?></font></td><td><div style="float:left;">&emsp;&emsp;&emsp;</div><input id="pvspingsitemap" type="button" value="Notify search Engines" class="button-primary" style="float:left;"  /><img  src="<?php echo pvs_PLUGIN_URL; ?>/images/ajax-loader.gif"  class="waiting" id="pvsping" style="display:none; float:left;">&emsp;&emsp;<b><?php _e('Previous Ping Time','pvs'); ?>:</b><font color="green"><b><?php echo get_option('pvs_ping_time'); ?></b></font></td>
	  
	

	  
	  
	  
	  </tbody>
	  
	 </table>
    <br /><br />	
    <div id="pvssitemapgeneratestatus" style="display:none; background-color:#ffffe0; border-color: #e6db55;  border-width: 1px; border-style: solid; width :auto; height:auto;">
    </div><br /><br />	   

     </form>
    </div>

	<?php }
	
	public function pvs_register_scripts() {
	   wp_register_script( 'pvs2', ''.pvs_PLUGIN_URL.'js/pvs2.js' );
	   wp_register_style( 'pvs2',  ''.pvs_PLUGIN_URL.'css/pvs2.css' );
       wp_register_script( 'pvs1', ''.pvs_PLUGIN_URL.'js/pvs1.js');
	   wp_register_style( 'pvs1',  ''.pvs_PLUGIN_URL.'css/pvs1.css' );
	  
	}
	

	
	

	
	 public function pvs_register_settings() {
	   register_setting('pvs_settings_group','pvs_settings');
	 }
	 
	
	

}


$pvs_admin_settings_class= new pvs_admin_settings_class();
?>