<?php
class pvs_ping_sitemap_class {
    public function __construct() {
	global $pvs_options;
	 add_action('wp_ajax_ping_videositemap', array(&$this, 'pvs_ajax_ping_sitemap'));
	 
	  if ( (isset($pvs_options['autoping'])) && ($pvs_options['autoping'] == "on") ) {
   
     
    
   add_action('save_post', array(&$this, 'pvs_ping_sitemap_function_with_post_update'));
   add_action('draft_to_publish', array(&$this, 'pvs_ping_sitemap_function_with_post_update'));
   add_action('pending_to_publish', array(&$this, 'pvs_ping_sitemap_function_with_post_update'));
   
   
   }
	 
	}
	public function pvs_ajax_ping_sitemap() {
	$this->pvs_ping_sitemap_function();
	die();
	}
	
	public function pvs_ping_sitemap_function() {
     global $pvs_options;
	
	if (isset($pvs_options['xmltitle']) && ($pvs_options['xmltitle'] == "on") && ($pvs_options['xmltitlename'] != '')) {
	$sitemaptitle=$pvs_options['xmltitlename'];
    } else {
	$sitemaptitle='video-sitemap';
    }
    
	if ( isset($pvs_options['folder']) && $pvs_options['foldername'] !='' ) {
	$pvssitemapurl=''.site_url().'/'.$pvs_options['foldername'].'/'.$sitemaptitle.'.xml';
	} else {
	$pvssitemapurl=''.site_url().'/'.$sitemaptitle.'.xml';
	}

    $this->ping_search_engines($pvssitemapurl,'google');

    $this->ping_search_engines($pvssitemapurl,'bing');

    
    }
	
	public function pvs_ping_sitemap_function_with_post_update() {
     global $pvs_options;
	 
	if (isset($pvs_options['xmltitle']) && ($pvs_options['xmltitle'] == "on") && ($pvs_options['xmltitlename'] != '')) {
	$sitemaptitle=$pvs_options['xmltitlename'];
    } else {
	$sitemaptitle='video-sitemap';
    }
	
    if ( isset($pvs_options['folder']) && $pvs_options['foldername'] !='' ) {
	$pvssitemapurl=''.site_url().'/'.$pvs_options['foldername'].'/'.$sitemaptitle.'.xml';
	} else {
	$pvssitemapurl=''.site_url().'/'.$sitemaptitle.'.xml';
	}
	

    $this->ping_search_engines_with_post_update($pvssitemapurl,'google');

    $this->ping_search_engines_with_post_update($pvssitemapurl,'bing');

    
    }
	
	
	public function ping_search_engines($pvssitemapurl,$searchengine) {

	switch ($searchengine) {
		case 'bing':
			$pingurl = "http://www.bing.com/webmaster/ping.aspx?siteMap=$pvssitemapurl";
			break;
		
		case 'google':
			$pingurl = "http://www.google.com/webmasters/sitemaps/ping?sitemap=$pvssitemapurl";
			break;
		
		default:
      		 return false;
	}

	$curl_handle=curl_init();
	curl_setopt($curl_handle,CURLOPT_URL,$pingurl);
	curl_setopt($curl_handle,CURLOPT_CONNECTTIMEOUT,2);
	curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
	$buffer = curl_exec($curl_handle);
	curl_close($curl_handle);

	if (empty($buffer))
	{
		echo '<tr><td><font size="02" color="black">'.__('Ping to ','pvsseo').'<a href="'.$pingurl.'"><font size="02" color="green">'.$searchengine.'</font></a> '.__('was unsuccessful.Please try again later','pvsseo').'.</font></td></tr><br />';
	     $currenttime    = 'unsuccessfull ping at '.current_time( 'mysql' ).' ';
		update_option('pvs_ping_time',$currenttime);
	}
	else
	{
		echo '<tr><td><font size="02" color="black">'.__('Your sitemap is successfully notified to ','pvsseo').' <a href="'.$pingurl.'"><font size="02" color="green">'.$searchengine.'</font></a>.</font></td></tr><br />';
		$currenttime    = current_time( 'mysql' );
	    update_option('pvs_ping_time',$currenttime);
	}

    }
	
	public function ping_search_engines_with_post_update($pvssitemapurl,$searchengine) {

	switch ($searchengine) {
		case 'bing':
			$pingurl = "http://www.bing.com/webmaster/ping.aspx?siteMap=$pvssitemapurl";
			break;
		
		case 'google':
			$pingurl = "http://www.google.com/webmasters/sitemaps/ping?sitemap=$pvssitemapurl";
			break;
		
		default:
      		 return false;
	}

	$curl_handle=curl_init();
	curl_setopt($curl_handle,CURLOPT_URL,$pingurl);
	curl_setopt($curl_handle,CURLOPT_CONNECTTIMEOUT,2);
	curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
	$buffer = curl_exec($curl_handle);
	curl_close($curl_handle);

	if (empty($buffer))
	{
		$currenttime    = 'unsuccessfull ping at '.current_time( 'mysql' ).' ';
		update_option('pvs_ping_time',$currenttime);
	}
	else
	{
		$currenttime    = current_time( 'mysql' );
	    update_option('pvs_ping_time',$currenttime);
	}

    }
	

}
new pvs_ping_sitemap_class();
?>