<?php
class pvs_schema_markup_class {
     public function __construct() {
	  global $pvs_options;
	 if (!isset($pvs_options['pvs_rich']) ) {
	  add_action('the_content', array(&$this, 'pvs_schema_markup_function'));
	  }
	  
	 }
	 
	 public function pvs_schema_markup_function($content) {
	     global $post;
    $thumbloc       = get_post_meta( $post->ID, 'thumbloc', true );
    $thumbtitle     = get_post_meta( $post->ID, 'thumbtitle', true );
    $thumbdesc      = get_post_meta( $post->ID, 'thumbdesc', true );
    $thumbplayer    = get_post_meta( $post->ID, 'thumbplayer', true );
    $thumbduration  = get_post_meta( $post->ID, 'thumbduration', true );
    $family         = get_post_meta( $post->ID, 'family', true );
    $thumbpubdate   = get_post_meta( $post->ID, 'thumbpubdate', true );
    $pvsdisable     = get_post_meta( $post->ID, 'pvsdisable', true );
	
    if (((is_single()) || (is_page())) && ($thumbloc !='') && ($pvsdisable != "yes")) {
    $extra_content='<div itemprop="video" itemscope itemtype="http://schema.org/VideoObject" >
<meta itemprop="name" content="'.$thumbtitle.'" />
<meta itemprop="duration" content="'.$thumbduration.'S" />
<meta itemprop="thumbnail" content="'.$thumbloc.'" />
<span itemprop="description">'.$thumbdesc.'</span>
<meta itemprop="uploadDate" content="'.$thumbpubdate.'">
<meta itemprop="embedUrl" content="'.$thumbplayer.'">
</div>';
    
     $content .= $extra_content;

    }
    return $content;
	 }
}

new pvs_schema_markup_class();
?>